m4_ifdef({_OPS_}, {}, {m4_define({_OPS_}, 10.0)})

m4_define({m4_inner_most_dodepth}, 3)

m4_ifdef( {nn_1}, {}, {m4_define({nn_1},1)})
m4_ifdef( {nn_2}, {}, {m4_define({nn_2},1)})
m4_ifdef( {nn_3}, {}, {m4_define({nn_3},1)})

m4_ifdef( {tn_1}, {}, {m4_define({tn_1},1)})
m4_ifdef( {tn_2}, {}, {m4_define({tn_2},1)})
m4_ifdef( {tn_3}, {}, {m4_define({tn_3},1)})

m4_ifdef( {nt_1}, {}, {m4_define({nt_1},1)})
m4_ifdef( {nt_2}, {}, {m4_define({nt_2},1)})
m4_ifdef( {nt_3}, {}, {m4_define({nt_3},1)})

m4_ifdef( {tt_1}, {}, {m4_define({tt_1},1)})
m4_ifdef( {tt_2}, {}, {m4_define({tt_2},1)})
m4_ifdef( {tt_3}, {}, {m4_define({tt_3},1)})

*
************************************************************************
*
*     File of the DOUBLE PRECISION Level-3 BLAS.
*     ==========================================
*
*     SUBROUTINE DGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,
*    $                   BETA, C, LDC )
*
*     SUBROUTINE DSYMM ( SIDE,   UPLO,   M, N,    ALPHA, A, LDA, B, LDB,
*    $                   BETA, C, LDC )
*
*     SUBROUTINE DSYRK ( UPLO,   TRANS,     N, K, ALPHA, A, LDA,
*    $                   BETA, C, LDC )
*
*     SUBROUTINE DSYR2K( UPLO,   TRANS,     N, K, ALPHA, A, LDA, B, LDB,
*    $                   BETA, C, LDC )
*
*     SUBROUTINE DTRMM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,
*    $                   B, LDB )
*
*     SUBROUTINE DTRSM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,
*    $                   B, LDB )
*
*     See:
*
*        Dongarra J. J.,   Du Croz J. J.,   Duff I.  and   Hammarling S.
*        A set of  Level 3  Basic Linear Algebra Subprograms.  Technical
*        Memorandum No.88 (Revision 1), Mathematics and Computer Science
*        Division,  Argonne National Laboratory, 9700 South Cass Avenue,
*        Argonne, Illinois 60439.
*
*
************************************************************************
*
      SUBROUTINE m4_ifdef({_RELEASE_},{},{T})DGEMM ( TRANSA, TRANSB, M, N, K, ALPHA,
     $                     A, LDA, B, LDB, BETA, C, LDC )
	      implicit double precision (a-h,o-z)
*     .. Scalar Arguments ..
      CHARACTER*1        TRANSA, TRANSB
      INTEGER            M, N, K, LDA, LDB, LDC
      DOUBLE PRECISION   ALPHA, BETA
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  DGEMM  performs one of the matrix-matrix operations
*
*     C := alpha*op( A )*op( B ) + beta*C,
*
*  where  op( X ) is one of
*
*     op( X ) = X   or   op( X ) = X',
*
*  alpha and beta are scalars, and A, B and C are matrices, with op( A )
*  an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
*
*  Parameters
*  ==========
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n',  op( A ) = A.
*
*              TRANSA = 'T' or 't',  op( A ) = A'.
*
*              TRANSA = 'C' or 'c',  op( A ) = A'.
*
*           Unchanged on exit.
*
*  TRANSB - CHARACTER*1.
*           On entry, TRANSB specifies the form of op( B ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSB = 'N' or 'n',  op( B ) = B.
*
*              TRANSB = 'T' or 't',  op( B ) = B'.
*
*              TRANSB = 'C' or 'c',  op( B ) = B'.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry,  M  specifies  the number  of rows  of the  matrix
*           op( A )  and of the  matrix  C.  M  must  be at least  zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry,  N  specifies the number  of columns of the matrix
*           op( B ) and the number of columns of the matrix C. N must be
*           at least zero.
*           Unchanged on exit.
*
*  K      - INTEGER.
*           On entry,  K  specifies  the number of columns of the matrix
*           op( A ) and the number of rows of the matrix op( B ). K must
*           be at least  zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION.
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
*           k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
*           Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
*           part of the array  A  must contain the matrix  A,  otherwise
*           the leading  k by m  part of the array  A  must contain  the
*           matrix A.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. When  TRANSA = 'N' or 'n' then
*           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*           least  max( 1, k ).
*           Unchanged on exit.
*
*  B      - DOUBLE PRECISION array of DIMENSION ( LDB, kb ), where kb is
*           n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
*           Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
*           part of the array  B  must contain the matrix  B,  otherwise
*           the leading  n by k  part of the array  B  must contain  the
*           matrix B.
*           Unchanged on exit.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in the calling (sub) program. When  TRANSB = 'N' or 'n' then
*           LDB must be at least  max( 1, k ), otherwise  LDB must be at
*           least  max( 1, n ).
*           Unchanged on exit.
*
*  BETA   - DOUBLE PRECISION.
*           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*           supplied as zero then C need not be set on input.
*           Unchanged on exit.
*
*  C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
*           Before entry, the leading  m by n  part of the array  C must
*           contain the matrix  C,  except when  beta  is zero, in which
*           case C need not be set on entry.
*           On exit, the array  C  is overwritten by the  m by n  matrix
*           ( alpha*op( A )*op( B ) + beta*C ).
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            NOTA, NOTB
m4_dnl      INTEGER            I, INFO, J, L, NCOLA, NROWA, NROWB
      INTEGER            I, INFO, J, NROWA, NROWB
m4_dnl      DOUBLE PRECISION   TEMP
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Executable Statements ..
*
*     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
*     transposed and set  NROWA, NCOLA and  NROWB  as the number of rows
*     and  columns of  A  and the  number of  rows  of  B  respectively.
*
      NOTA  = LSAME( TRANSA, 'N' )
      NOTB  = LSAME( TRANSB, 'N' )
      IF( NOTA )THEN
         NROWA = M
m4_dnl         NCOLA = K
      ELSE
         NROWA = K
m4_dnl         NCOLA = M
      END IF
      IF( NOTB )THEN
         NROWB = K
      ELSE
         NROWB = N
      END IF
*
*     Test the input parameters.
*
      INFO = 0
      IF(      ( .NOT.NOTA                 ).AND.
     $         ( .NOT.LSAME( TRANSA, 'C' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'T' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.NOTB                 ).AND.
     $         ( .NOT.LSAME( TRANSB, 'C' ) ).AND.
     $         ( .NOT.LSAME( TRANSB, 'T' ) )      )THEN
         INFO = 2
      ELSE IF( M  .LT.0               )THEN
         INFO = 3
      ELSE IF( N  .LT.0               )THEN
         INFO = 4
      ELSE IF( K  .LT.0               )THEN
         INFO = 5
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 8
      ELSE IF( LDB.LT.MAX( 1, NROWB ) )THEN
         INFO = 10
      ELSE IF( LDC.LT.MAX( 1, M     ) )THEN
         INFO = 13
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DGEMM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ( ALPHA.EQ.ZERO ).OR.( K.EQ.0 ) ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     And if  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         IF( BETA.EQ.ZERO )THEN
            DO 20, J = 1, N
               DO 10, I = 1, M
                  C( I, J ) = ZERO
   10          CONTINUE
   20       CONTINUE
         ELSE
            DO 40, J = 1, N
               DO 30, I = 1, M
                  C( I, J ) = BETA*C( I, J )
   30          CONTINUE
   40       CONTINUE
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( NOTB )THEN
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B + beta*C.
*
m4_dnl            DO 90, J = 1, N
m4_dnl               IF( BETA.EQ.ZERO )THEN
m4_dnl                  DO 50, I = 1, M
m4_dnl                     C( I, J ) = ZERO
m4_dnl   50             CONTINUE
m4_dnl               ELSE IF( BETA.NE.ONE )THEN
m4_dnl                  DO 60, I = 1, M
m4_dnl                     C( I, J ) = BETA*C( I, J )
m4_dnl   60             CONTINUE
m4_dnl               END IF
m4_dnl               DO 80, L = 1, K
m4_dnl                  IF( B( L, J ).NE.ZERO )THEN
m4_dnl                     TEMP = ALPHA*B( L, J )
m4_dnl                     DO 70, I = 1, M
m4_dnl                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
m4_dnl   70                CONTINUE
m4_dnl                  END IF
m4_dnl   80          CONTINUE
m4_dnl   90       CONTINUE
            call dgemm1 ( m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
         ELSE
*
*           Form  C := alpha*A'*B + beta*C
*
m4_dnl            DO 120, J = 1, N
m4_dnl               DO 110, I = 1, M
m4_dnl                  TEMP = ZERO
m4_dnl                  DO 100, L = 1, K
m4_dnl                     TEMP = TEMP + A( L, I )*B( L, J )
m4_dnl  100             CONTINUE
m4_dnl                  IF( BETA.EQ.ZERO )THEN
m4_dnl                     C( I, J ) = ALPHA*TEMP
m4_dnl                  ELSE
m4_dnl                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
m4_dnl                  END IF
m4_dnl  110          CONTINUE
m4_dnl  120       CONTINUE
            call dgemm2 ( m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
         END IF
      ELSE
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B' + beta*C
*
m4_dnl            DO 170, J = 1, N
m4_dnl               IF( BETA.EQ.ZERO )THEN
m4_dnl                  DO 130, I = 1, M
m4_dnl                     C( I, J ) = ZERO
m4_dnl  130             CONTINUE
m4_dnl               ELSE IF( BETA.NE.ONE )THEN
m4_dnl                  DO 140, I = 1, M
m4_dnl                     C( I, J ) = BETA*C( I, J )
m4_dnl  140             CONTINUE
m4_dnl               END IF
m4_dnl               DO 160, L = 1, K
m4_dnl                  IF( B( J, L ).NE.ZERO )THEN
m4_dnl                     TEMP = ALPHA*B( J, L )
m4_dnl                     DO 150, I = 1, M
m4_dnl                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
m4_dnl  150                CONTINUE
m4_dnl                  END IF
m4_dnl  160          CONTINUE
m4_dnl  170       CONTINUE
            call dgemm3 ( m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
         ELSE
*
*           Form  C := alpha*A'*B' + beta*C
*
m4_dnl            DO 200, J = 1, N
m4_dnl               DO 190, I = 1, M
m4_dnl                  TEMP = ZERO
m4_dnl                  DO 180, L = 1, K
m4_dnl                     TEMP = TEMP + A( L, I )*B( J, L )
m4_dnl  180             CONTINUE
m4_dnl                  IF( BETA.EQ.ZERO )THEN
m4_dnl                     C( I, J ) = ALPHA*TEMP
m4_dnl                  ELSE
m4_dnl                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
m4_dnl                  END IF
m4_dnl  190          CONTINUE
m4_dnl  200       CONTINUE
            call dgemm4 ( m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
         END IF
      END IF
*
      RETURN
*
*     End of DGEMM .
*
      END
*
* ----------------------------------------------------------------------
*
      SUBROUTINE dgemm1 ( M, N, K, ALPHA, A, LDA, B, LDB, BETA, C, LDC )
* Case TRANSA='n', TRANSB='n'
	      implicit double precision (a-h,o-z)
*     .. Scalar Arguments ..
      INTEGER            M, N, K, LDA, LDB, LDC
      DOUBLE PRECISION   ALPHA, BETA
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )
      INTEGER            I, J, L
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*
            m4_local(t, j, l)
            m4_do(j, 1, n, 1, nn_2, {
               if( beta.eq.zero )then
                  m4_do(i, 1, m, 1, nn_1, {
                     m4_expand(j, i, {c( i, j ) = zero})
                  })
               else if( beta.ne.one )then
                  m4_do(i, 1, m, 1, nn_1, {
                     m4_expand(j, i, {c( i, j ) = beta*c( i, j )})
                  })
               end if
               m4_do(l, 1, k, 1, nn_3, {
                  m4_expand(j, l, {t = alpha*b( l, j )})
                  m4_do(i, 1, m, 1, nn_1, {
		      m4_expand(j, i, {
                         c( i, j ) = c( i, j ) m4_expand(l,{&+ t*a( i, l )})
                      })
                  })
               })
            })
            m4_undefine({t})
*
      RETURN
      END
*
* ----------------------------------------------------------------------
*
      SUBROUTINE DGEMM2 ( M, N, K, ALPHA, A, LDA, B, LDB, BETA, C, LDC )
* Case TRANSA='t', TRANSB='n'
	      implicit double precision (a-h,o-z)
*     .. Scalar Arguments ..
      INTEGER            M, N, K, LDA, LDB, LDC
      DOUBLE PRECISION   ALPHA, BETA
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )
      INTEGER            I, J, L
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*
            m4_local(t, i, j)
            m4_do(j, 1, n, 1, tn_2, {
               m4_do(i, 1, m, 1, tn_1, {
                  m4_expand(j, i, {t = zero})
                  m4_do(l, 1, k, 1, tn_3, {
                     m4_expand(j, i, {
                        t=t m4_expand(l, {&+a( l, i )*b( l, j )})
                     })
                  })
                  if( beta.eq.zero )then
                     m4_expand(j, i, {c( i, j ) = alpha*t})
                  else
                     m4_expand(j, i, {c( i, j ) = alpha*t + beta*c( i, j )})
                  end if
               })
            })
            m4_undefine({t})
*
      RETURN
      END
*
* ----------------------------------------------------------------------
*
      SUBROUTINE DGEMM3 ( M, N, K, ALPHA, A, LDA, B, LDB, BETA, C, LDC )
* Case TRANSA='n', TRANSB='t'
	      implicit double precision (a-h,o-z)
*     .. Scalar Arguments ..
      INTEGER            M, N, K, LDA, LDB, LDC
      DOUBLE PRECISION   ALPHA, BETA
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )
      INTEGER            I, J, L
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*
            m4_local(t,j,l)
            m4_do(j, 1, n, 1, nt_2, {
               if( beta.eq.zero )then
                  do i = 1, m
                     m4_expand(j, {c( i, j ) = zero})
                  enddo
               else if( beta.ne.one )then
                  do i = 1, m
                     m4_expand(j, {c( i, j ) = beta*c( i, j )})
                  enddo
               end if
               m4_do(l, 1, k, 1, nt_3, {
                  m4_expand(j, l, {t = alpha*b( j, l )})
                  m4_do(i, 1, m, 1, nt_1, {
                     m4_expand(j, i, {
                        c( i, j ) = c( i, j ) m4_expand(l, {&+t*a( i, l )})
                     })
                  })
               })
            })
            m4_undefine({t})
*
      RETURN
      END
*
* ----------------------------------------------------------------------
*
      SUBROUTINE dgemm4 ( M, N, K, ALPHA, A, LDA, B, LDB, BETA, C, LDC )
* Case TRANSA='t', TRANSB='t'
	      implicit double precision (a-h,o-z)
*     .. Scalar Arguments ..
      INTEGER            M, N, K, LDA, LDB, LDC
      DOUBLE PRECISION   ALPHA, BETA
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )
      INTEGER            I, J, L
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*
            m4_local(t,i,j)
            m4_do(j, 1, n, 1, tt_2, {
               m4_do(i, 1, m, 1, tt_1, {
                  m4_expand(j, i, {t = zero})
                  m4_do(l, 1, k, 1, tt_3, {
                     m4_expand(j, i, {
                        t = t m4_expand(l, {&+a( l, i )*b( j, l )})
                     })
                  })
                  if( beta.eq.zero )then
                     m4_expand(j, i, {c( i, j ) = alpha*t})
                  else
                     m4_expand(j, i, {c( i, j ) = alpha*t + beta*c( i, j )})
                  end if
               })
            })
            m4_undefine({t})
*
      RETURN
      END

m4_ifdef({_RELEASE_},{},{
c
c-----------------------------------------------------------------------
c
      program test
      implicit double precision (a-h,o-z)
      parameter (LA=512*513)
      double precision a(la), b(la), c1(la)
  m4_ifdef({_MFLOPS_ONLY_},{},{
      double precision c2(la)
      print *,'Enter N and LDA(=LDB=LDC): '
  })
      read(*,*) n, lda
      if (n*lda.gt.la .or. lda.lt.n) then
         print *,'Invalid input values for n or lda!'
         stop
      endif
      call sub(n, a,lda, b,lda, c1,lda, c2,lda)
      stop
      end
c
c-----------------------------------------------------------------------
c
      subroutine sub(n, a,lda, b,ldb, c1,ldc1, c2,ldc2)
      implicit double precision (a-h,o-z)
      double precision a(lda,n), b(ldb,n), c1(ldc1,n), c2(ldc2,n)
      real*4 t0,t1,f2
      character*1 transa, transb
  m4_ifdef({_MFLOPS_ONLY_},{},{
      real*4 f1,spup,ops
  })
      external second
      real*4 second
*
      external dbeg
      logical reset
      data reset /.true./
*
c
  m4_ifdef({_MFLOPS_ONLY_},{},{
      print *,'Enter TRANSA and TRANSB (''T'' or ''N''):'
  })
      read(*,*) transa, transb
c
      do j=1,n
         do i=1,n
            a(i,j)=dbeg(reset)
            b(i,j)=dbeg(reset)
         enddo
      enddo
c
      do j=1,n
         do i=1,n
            c1(i,j)=dbeg(reset)
m4_ifdef({_MFLOPS_ONLY_},{},{
            c2(i,j)=c1(i,j)
})
         enddo
      enddo
c
      M=N
      K=N
      ops=(2.0*M*FLOAT(N)*K)*1e-6
      nit=1
  m4_ifdef({_MFLOPS_ONLY_},{
      nit=max(1, int(_OPS_/ops))
      ops=nit*ops
  })

      alpha=1.2
      beta=1.1

      t0=second()
      do i=1,nit
      if (nit.gt.1) then
*        call matcopy(n, n, c2, ldc2, c1, ldc1)
         beta=1.0/beta
      endif
      call TDGEMM ( transa, transb, N, N, N, ALPHA, A, LDA, B, LDB,
     $              BETA, C1, LDC1 )
      enddo
      t1=second()
      if (t0.lt.t1) then
         f2=ops/(t1-t0)
      else
         f2=0.0
      endif

  m4_ifdef({_MFLOPS_ONLY_},{
      print *, f2
  },{
      print 1001,n, lda, transa, transb,
     *      'NN_1=',nn_1, 'NN_2=', nn_2, 'NN_3=',nn_3,
     *      'NT_1=',nt_1, 'NT_2=', nt_2, 'NT_3=',nt_3,
     *      'TN_1=',tn_1, 'TN_2=', tn_2, 'TN_3=',tn_3,
     *      'TT_1=',tt_1, 'TT_2=', tt_2, 'TT_3=',tt_3
1001  format(' N=',I4,'   LDA=',I4, '   TRANSA=',A1,'   TRANSB=',A1,/,
     *       ('   ',A,I3,'   ',A,I3,'   ',A,I3))

      t0=second()
      do i=1,nit
      call DGEMM ( transa, transb, N, N, N, ALPHA, A, LDA, B, LDB,
     $             BETA, C2, LDC2 )
      enddo
      t1=second()
      if (t0.lt.t1) then
         f1=ops/(t1-t0)
      else
         f1=0.0
      endif
      if (f1.eq.0.0) then
         spup=0.0
      else
         spup=f2/f1
      endif

      call comp(n, c1,ldc1, c2,ldc2)

      print 1000,f1,f2,spup
1000  format(' Normal=',F7.3,'   Unrolled=',F7.3,'   Speedup=',F7.3)
  })
      return
      end

  m4_ifdef({_MFLOPS_ONLY_},{},{

c
c-----------------------------------------------------------------------
c
      subroutine comp(n, a,lda, b,ldb)
      implicit double precision (a-h,o-z)
      dimension a(lda,n), b(ldb,n)
      error=0.0
      do j=1,n
         do i=1,n
            error=max(error,abs(a(i,j)-b(i,j)))
         enddo
      enddo
      print *,'      Maximum error = ',error
      return
      end

  })
})
